 ###############################################
#                                               #
#                O M G Y S U !                  #
#     v2.0 (23/11/2010)    2010 MenzAgitat     #
#                                               #
#   IRC: irc.epiknet.org  #boulets / #eggdrop   #
#          http://www.boulets-roxx.com          #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
 ###############################################

#
# Description
#
# OMGYSU!, dont le dlicieux acronyme signifie "Oh My God You Shut Up!", vous
# permet d'imposer le silence  un individu ou  tout un chan de faon trs
# efficace.
# Je l'utilise personnellement comme outil d'appoint pour grer un chan de
# boulets o tout le monde est op automatiquement; je vous laisse imaginer le
# carnage potentiel sans ce genre d'atouts.
#
# Utilis contre un individu, il pose un ban quiet ainsi qu'un ban nick change
# (~q et ~n, si votre serveur le supporte) qu'il maintient, et empche la cible
# d'tre voice/halfope/ope par quiconque. Si votre serveur ne supporte pas
# les bans tendus, le script peut aussi adopter un autre comportement en
# modrant le chan (mode +m), en dopant/dhalfopant/dvoiant la cible et en
# maintenant ces modes. Le souci avec cette 2me mthode est qu'elle risque
# d'ennuyer d'autres utilisateurs si tout le monde n'est pas habituellement au
# moins voice sur votre chan.
# Il est possible de dfinir une dure au bout de laquelle la restriction sera
# leve automatiquement. Si aucune dure n'est spcifie, le script prendra
# une valeur par dfaut de 3mn (paramtrable).
#
# Il est galement possible d'imposer le silence sur un chan entier au moyen
# d'une autre commande. Le script modre alors le chan (mode +m), bloque les
# changements de nick dans le but d'empcher le nick chatting (mode +N) et
# s'assure que ces modes seront maintenus, puis il dop/dhalfop/dvoice
# tout le monde sauf les utilisateurs portant certains flags (que vous pouvez
# dfinir). Tant que cette modration est active, le bot empche quiconque
# d'tre op/halfop/voic sauf par des utilisateurs portant des flags les
# exemptant. L encore il est possible de dfinir la dure de la modration et
# une valeur par dfaut est utilise en l'absence de ce paramtre.
#
# L'activation/dsactivation du script sur chaque chan se fait au moyen de la
# commande .chanset #nomduchan [+/-]OMGYSU ( taper en partyline)
# Par dfaut, le script est activ sur tous les chans sur lesquels l'eggdrop se
# trouve au moment du 1er lancement du script.
#

#
# Syntaxe
#
# !chut <nick> [dure en mn]		: impose le silence  un individu
# !chut <nick> <off>						: lve la restriction de parole sur un individu
# !vg [dure en mn]							: impose le silence sur un chan
# !vg <off>											: lve la restriction de parole sur un chan
#

#
# Changelog
#
#	1.0		- 1re version
#	2.0		- Correction : il n'est plus possible d'utiliser la commande !chut
#					contre l'eggdrop.
#				- Ajout : nouvelle option permettant ou non de retourner la commande
#					!chut contre celui qui l'a tape si celle-ci visait l'eggdrop.
#				- Ajout : nouvelle option permettant d'afficher un message de votre
#					choix lorsqu'une commande du script est utilise.
#				- Modification : OMGYSU! utilise maintenant le ban tendu ~n (si
#					disponible) afin d'empcher le nick chatting. En ce qui concerne
#					le !vg, Le mode de chan +N est utilis en conjonction du mode +m.
#				- Correction : lorsque l'on spcifie une dure d'1mn, le bot enlve
#					parfois la punition aprs quelques secondes. C'est d au
#					fonctionnement interne des timers : l'eggdrop dcrmente un timer 
#					chaque passage de minute, ce qui fait que si on lance un
#					{timer 1 blabla}  14h22mn57s, il expirera  14h23mn00s, donc 3
#					secondes aprs. La marge d'imprcision d'un timer est donc de 59,99
#					secondes, ce qui le rend inutilisable lorsque la prcision compte.
#				- Correction : une incohrence dans le code posait problme lorsqu'on
#					mettait un !chut sur plusieurs personnes, puis qu'on tentait de
#					"!chut off" ensuite. En effet, il faut savoir que lorsqu'on modifie
#					un array, cela interromp toutes les recherches en cours sur lui.
#				- Correction : les nicks contenant des caractres spciaux ne gnent
#					plus le fonctionnement du script.
#				- Ajout : nouveau paramtre fast_queue_compatibility afin d'assurer la
#					compatibilit du script avec les versions 1.6.19 et 1.6.20 d'Eggdrop.
#				- Modification : il est n'est plus autoris de mettre 0 secondes comme
#					dure.
#				- Correction : si l'option single_target_shutup_method est rgle sur 2,
#					le chan est maintenant d-modr (-m) si le dernier !chut actif est
#					lev, et chaque utilisateur dont la punition se termine est voic s'il
#					reste encore des !chut actifs sur d'autres utilisateurs.
#

#
# LICENCE:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#


# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [string range [lindex $version 0] 0 5] "."] ""] < 1619 } { putloglev o * "\00304\002\[OMGYSU! - ERREUR\]\002\003 La version de votre eggdrop est \00304\002$version\002\003; \002OMGYSU!\002 ne fonctionnera correctement que sur les eggdrops version 1.6.19 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[OMGYSU! - ERREUR\]\002\003 \002OMGYSU!\002 ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
if {[info commands OMGYSU::uninstall] eq "::OMGYSU::uninstall"} { OMGYSU::uninstall }
namespace eval OMGYSU {


	###########################
	#				PARAMETRES        #
	###########################

	#### COMMANDES ET AUTORISATIONS
	# commande et autorisations ncessaires pour imposer le silence  un individu
	variable chut_cmd "!chut"
	variable chut_auth "mno|mno"
	# commande et autorisations ncessaires pour imposer le silence  tout le monde sur un chan
	variable vg_cmd "!vg"
	variable vg_auth "mn|mn"

	# Mthode utilise pour imposer le silence  un individu
	# 1	=	ban tendu "quiet" ~q:*!ident@host + "nick change" ~n:*!ident@host  (recommand)
	# 2	=	mode +m sur le chan (et mode +N en cas d'utilisation de !vg uniquement) :
	# 		 utiliser si votre serveur ne supporte pas les bans tendus.
	variable single_target_shutup_method 1

	# Message  afficher lorsqu'une des commandes est utilise.
	# Si vous ne voulez aucun message, mettez ""
	# Vous pouvez utiliser la variable %shutup_duration% qui sera automatiquement
	# remplace par la dure de la modration.
	# Le premier message sera affich si la dure de la modration est suprieure
	#  1mn, sinon le second message sera utilis.
	variable shutup_message "\00314Ces %shutup_duration% minutes de silence vous sont offertes par les biscottes CROC\003"
	variable shutup_message_single "\00314Cette minute de silence vous est offerte par les biscottes CROC\003"

	# Dure par dfaut de la modration en minutes
	# (si aucun temps n'est indiqu en paramtre)
	variable default_shutup_duration 3

	# Flags exempts des effets d'une mise au silence du chan complet.
	# Remarque : cette variable ne peut tre vide.
	variable vg_exempted_flags "mnb|mn"

	# Que faire si quelqu'un tente d'utiliser la commande !chut contre l'eggdrop ?
	# ( 1 = ne rien faire, 2 = retourner la commande contre celui qui l'a tape )
	variable self_defense_mode 2

	# Cette option sert  adapter la compatibilit du script en fonction de la
	# version d'eggdrop que vous utilisez.
	# Si la version de votre eggdrop est 1.6.19 mettez 0
	# Si la version de votre eggdrop est 1.6.20 mettez 1
	variable fast_queue_compatibility 0

	# Ce script est-il destin  fonctionner en conjonction avec Op Everyone ?
	# (du mme auteur, pas de release publique  ce jour)
	# Si vous ne savez pas  quoi correspond cette option et les consquences
	# qu'elle a, n'y touchez pas.
	variable op_everyone_used 0



####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	###
	### Initialisation
	###
  variable scriptname "OMGYSU!"
  variable version "2.0.20101123"
	variable unchut_running 0
	# Prparation de la mise en forme de la variable vg_exempted_flags en vue
	# d'une utilisation avec chanlist
	set vg_global_flags "" ; set vg_local_flags ""
	set split_vg_exempted_flags [split $vg_exempted_flags "|"]
	foreach element [split [lindex $split_vg_exempted_flags 0] ""] {
		set vg_global_flags "$vg_global_flags-$element"
	}
	foreach element [split [lindex $split_vg_exempted_flags 1] ""] {
		set vg_local_flags $vg_local_flags-$element
	}
	set formatted_vg_exempted_flags $vg_global_flags&$vg_local_flags
	variable shutup_table ;	array set shutup_table {}	
	# Initialisation du flag OMGYSU et activation par dfaut sur tous les chans
	# s'il s'agit du 1er lancement du script.
	if { [lsearch -regexp [channel info [lindex [set chans [channels]] 0]] {^(\+|\-)OMGYSU$}] == -1 } {
		setudef flag OMGYSU
		foreach channame $chans { channel set $channame +OMGYSU }
	} else {
		setudef flag OMGYSU
	}
	# Procdure de dsinstallation
	# (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$OMGYSU::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_timer [timers] {
			if { [string match "*[namespace current]::*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
		}
		foreach running_utimer [utimers] {
			if { [string match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		namespace delete ::OMGYSU
	}
}

###
### Impose le silence  un individu
###
proc OMGYSU::you_shutup {nick host hand chan arg} {
	if { ![channel get $chan OMGYSU] } {
		return
	} elseif { $arg eq "" } {
		puthelp "PRIVMSG $chan :\037Syntaxe\037 : \002$OMGYSU::chut_cmd\002 \00314<\003nick\00314> \[\003dure en mn\00314\]\003 \00307|\003 Impose le silence  un individu pendant la dure spcifie (sinon [set OMGYSU::default_shutup_duration]mn par dfaut)"
		puthelp "PRIVMSG $chan :ou : \002$OMGYSU::chut_cmd\002 \00314<\003nick\00314> <\003off\00314>\003 \00307|\003 Redonne la parole  un individu avant expiration du temps initial."
		return
	} elseif { ![onchan [set targetnick [lindex [split $arg] 0]]] } {
		puthelp "PRIVMSG $chan :\00314Je ne vois \002$targetnick\002 nulle part."
		return
	} elseif { [string tolower $targetnick] eq [string tolower $::botnick] } {
		if { $OMGYSU::self_defense_mode == 2 } {
			OMGYSU::damn_you_shutup $nick $nick $host $hand $chan $arg
		}
		return
	} elseif { ([::tcl::string::is digit [set option [lindex $arg 1]]]) && ($option ne "") && (!$option) } {
		puthelp "PRIVMSG $chan :\00314C'est pas long 0 secondes..."
		return
	} else {
		OMGYSU::damn_you_shutup $nick $targetnick $host $hand $chan $arg
		return
	}
}
proc OMGYSU::damn_you_shutup {nick targetnick host hand chan arg} {
	if { [set option [lindex $arg 1]] eq "off" } {
		variable unchut_running 1
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			if { [getchanhost $targetnick] eq [lindex $OMGYSU::shutup_table([set shutup_table_id [array nextelement OMGYSU::shutup_table $array_search_id]]) 1] } {
				pushmode $chan -b [lindex $OMGYSU::shutup_table($shutup_table_id) 2]
				pushmode $chan -b [lindex $OMGYSU::shutup_table($shutup_table_id) 3]
				flushmode $chan
				foreach running_timer [timers] {
					if { [string match "::OMGYSU::you_talk $shutup_table_id" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
				}
				foreach running_timer [utimers] {
					if { [string match "::OMGYSU::you_talk $shutup_table_id" [lindex $running_timer 1]] } { killutimer [lindex $running_timer 2] }
				}
				lappend indexes $shutup_table_id
			}
		}
		if { [llength $indexes] != 0 } {
			foreach index $indexes {
				unset OMGYSU::shutup_table($index)
			}
			if { ($OMGYSU::single_target_shutup_method == 2) && ([array size OMGYSU::shutup_table] == 0) } {
				pushmode $chan -m
				pushmode $chan -N
				flushmode $chan
			}
		} elseif { [array size OMGYSU::shutup_table] > 0 } {
			array donesearch OMGYSU::shutup_table $array_search_id
		}
		variable unchut_running 0
		return
	} else {
		variable shutup_table
		set targethost [getchanhost $targetnick]
		# si le script op_everyone.tcl est utilis conjointement, on arrte tous
		# les timers op en cours sur la cible
		if { $OMGYSU::op_everyone_used } {
			foreach running_timer [timers] {
				if { [string match -nocase "*opeveryone::op $chan $targetnick" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
			}
		}
		# si la dure n'a pas t spcifie, on applique la dure par dfaut
		if { (![string is digit [set shutup_duration $option]]) || ($shutup_duration eq "") } {
			set shutup_duration $OMGYSU::default_shutup_duration
		}
		if { $OMGYSU::single_target_shutup_method == 1 } {
			OMGYSU::putqueue "MODE $chan -o-h-v+b+b $targetnick $targetnick $targetnick [set banmask1 "~q:[set hostmask [OMGYSU::hostmask_process $targetnick $targethost 1]]"] [set banmask2 "~n:$hostmask"]"
		} else {
			OMGYSU::putqueue "MODE $chan -o-h-v+m $targetnick $targetnick $targetnick"
			set banmask1 [set banmask2 ""]
		}
		if { ($shutup_duration > 1) && ($OMGYSU::shutup_message ne "") } {
			putquick "PRIVMSG $chan :[subst [string map -nocase {%shutup_duration% $shutup_duration} $OMGYSU::shutup_message]]"
		} elseif { ($shutup_duration == 1) && ($OMGYSU::shutup_message_single ne "") } {
			putquick "PRIVMSG $chan :[subst [string map -nocase {%shutup_duration% $shutup_duration} $OMGYSU::shutup_message_single]]"
		}
		set shutup_table([set shutup_table_id [expr [array size shutup_table] + 1]]) [list $targetnick $targethost $banmask1 $banmask2 $chan]
		if { $shutup_duration > 1 } {
			timer $shutup_duration [list ::OMGYSU::you_talk $shutup_table_id]
		} else {
			utimer 60 [list ::OMGYSU::you_talk $shutup_table_id]
		}
		return
	}
}

###
### Impose le silence  tout un chan
###
proc OMGYSU::everybody_shutup {nick host hand chan arg} {
	if { ![channel get $chan OMGYSU] } { return }
	if { [set option [lindex $arg 0]] eq "off" } {
		variable unchut_running 1
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			if { $OMGYSU::shutup_table([set shutup_table_id [array nextelement OMGYSU::shutup_table $array_search_id]]) eq "- - - $chan" } {
				pushmode $chan -m
				pushmode $chan -N
				flushmode $chan
				# si le script op_everyone.tcl est utilis conjointement et tait actif sur ce
				# chan, on le ractive.
				if { $OMGYSU::op_everyone_used } {
					if { [lsearch $opeveryone::allowed_chans "$chan"] != -1 } {
						bind join -|- "$chan *" opeveryone::onjoin
					}
				}
				foreach running_timer [timers] {
					if { [string match "::OMGYSU::everybody_talk $shutup_table_id" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
				}
				foreach running_timer [utimers] {
					if { [string match "::OMGYSU::everybody_talk $shutup_table_id" [lindex $running_timer 1]] } { killutimer [lindex $running_timer 2] }
				}


				lappend indexes $shutup_table_id
			}
		}
		if { [llength $indexes] != 0 } {
			foreach index $indexes {
				unset OMGYSU::shutup_table($index)
			}
		} elseif { [array size OMGYSU::shutup_table] > 0 } {
			array donesearch OMGYSU::shutup_table $array_search_id
		}
		variable unchut_running 0
		return
	} elseif { ([::tcl::string::is digit $option]) && ($option ne "") && (!$option) } {
		puthelp "PRIVMSG $chan :\00314C'est pas long 0 secondes..."
		return
	} else {
		variable shutup_table
		set targetlist [chanlist $chan $OMGYSU::formatted_vg_exempted_flags] 
		# l'eggdrop s'exempte automatiquement de la liste des personnes  faire taire
		set targetlist [lreplace $targetlist [set index [lsearch $targetlist $::botnick]] $index]
		OMGYSU::putqueue "MODE $chan +m+N"
		foreach target $targetlist { pushmode $chan -o $target }
		foreach target $targetlist { pushmode $chan -h $target }
		foreach target $targetlist { pushmode $chan -v $target }
		flushmode $chan 
		# si le script op_everyone.tcl est utilis conjointement, arrt de sa fonction
		# auto-halfop/auto-op et arrt des timers op en cours
		if { $OMGYSU::op_everyone_used } {
			catch { unbind join -|- "$chan *" opeveryone::onjoin }
			foreach running_timer [timers] {
				if { [string match "*opeveryone::op*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
			}
		}
		# si la dure n'a pas t spcifie, on applique la dure par dfaut
		if { (![string is digit [set shutup_duration $option]]) || ($shutup_duration eq "") } {
			set shutup_duration $OMGYSU::default_shutup_duration
		}
		if { ($shutup_duration > 1) && ($OMGYSU::shutup_message ne "") } {
			putquick "PRIVMSG $chan :[subst [string map -nocase {%shutup_duration% $shutup_duration} $OMGYSU::shutup_message]]"
		} elseif { ($shutup_duration == 1) && ($OMGYSU::shutup_message_single ne "") } {
			putquick "PRIVMSG $chan :[subst [string map -nocase {%shutup_duration% $shutup_duration} $OMGYSU::shutup_message_single]]"
		}
		set shutup_table([set shutup_table_id [expr [array size shutup_table] + 1]]) [list - - - $chan]
		if { $shutup_duration > 1 } {
			timer $shutup_duration [list ::OMGYSU::everybody_talk $shutup_table_id]
		} else {
			utimer 60 [list ::OMGYSU::everybody_talk $shutup_table_id]
		}
		return
	}
}

###
### Leve du silence impos  un individu une fois le temps coul
###
proc OMGYSU::you_talk {shutup_table_id} {
	lassign $OMGYSU::shutup_table($shutup_table_id) targetnick targethost banmask1 banmask2 chan
	unset ::OMGYSU::shutup_table($shutup_table_id)
	if { $OMGYSU::single_target_shutup_method == 1 } {
		pushmode $chan -b $banmask1
		pushmode $chan -b $banmask2
		flushmode $chan
	} else {
		if { [array size OMGYSU::shutup_table] == 0 } {
			pushmode $chan -m
			flushmode $chan
		} else {
			pushmode $chan +v $targetnick
		}
	}
	return
}

###
### Leve du silence impos  tout un chan une fois le temps coul
###
proc OMGYSU::everybody_talk {shutup_table_id} {
	lassign $OMGYSU::shutup_table($shutup_table_id) targetnick targethost banmask chan
	pushmode $chan -m
	pushmode $chan -N
	flushmode $chan
	# si le script op_everyone.tcl est utilis conjointement et tait actif sur ce
	# chan, on le ractive.
	if { $OMGYSU::op_everyone_used } {
		if { [lsearch $opeveryone::allowed_chans "$chan"] != -1 } {
			bind join -|- "$chan *" opeveryone::onjoin
		}
	}
	unset ::OMGYSU::shutup_table($shutup_table_id)
	return
}

###
### Maintien du quiet ban et du statut dop/dhalfop/dvoic
###
proc OMGYSU::modes_management {nick host hand chan mode arg} {
	if { (![set array_size [array size OMGYSU::shutup_table]]) || ($OMGYSU::unchut_running) } { return }
	if { ($mode eq "-b") } {
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			if { ($arg eq [lindex [set table_element $OMGYSU::shutup_table([array nextelement OMGYSU::shutup_table $array_search_id])] 2]) || ($arg eq [lindex $table_element 3]) } {
				OMGYSU::putqueue "MODE $chan +b $arg"
				array donesearch OMGYSU::shutup_table $array_search_id
				break
			}
		}
		return
	} elseif { $mode eq "+v" } {
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			set shutup_table_id [array nextelement OMGYSU::shutup_table $array_search_id]
			if { [getchanhost $arg] eq [lindex $OMGYSU::shutup_table($shutup_table_id) 1] } {
				OMGYSU::putqueue "MODE $chan -v $arg"
			# on n'autorise pas l'eggdrop  voicer un utilisateur tant que !vg est actif sauf si cet utilisateur possde des flags qui l'exemptent
			} elseif { ($OMGYSU::shutup_table($shutup_table_id) eq "- - - $chan") && (($nick == $::botnick) || (![matchattr [nick2hand $nick] $OMGYSU::vg_exempted_flags $chan])) } {
				OMGYSU::putqueue "MODE $chan -v $arg"
			}
		}
		array donesearch OMGYSU::shutup_table $array_search_id
		return
	} elseif { $mode eq "+h" } {
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			set shutup_table_id [array nextelement OMGYSU::shutup_table $array_search_id]
			if { [getchanhost $arg] eq [lindex $OMGYSU::shutup_table($shutup_table_id) 1] } {
				OMGYSU::putqueue "MODE $chan -h $arg"
			# on n'autorise pas l'eggdrop  halfoper un utilisateur tant que !vg est actif sauf si cet utilisateur possde des flags qui l'exemptent
			} elseif { ($OMGYSU::shutup_table($shutup_table_id) eq "- - - $chan") && (($nick == $::botnick) || (![matchattr [nick2hand $nick] $OMGYSU::vg_exempted_flags $chan])) } {
				OMGYSU::putqueue "MODE $chan -h $arg"
			}
		}
		array donesearch OMGYSU::shutup_table $array_search_id
		return
	} elseif { $mode eq "+o" } {
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			set shutup_table_id [array nextelement OMGYSU::shutup_table $array_search_id]
			if { [getchanhost $arg] eq [lindex $OMGYSU::shutup_table($shutup_table_id) 1] } {
				OMGYSU::putqueue "MODE $chan -o $arg"
			# on n'autorise pas l'eggdrop  oper un utilisateur tant que !vg est actif sauf si cet utilisateur possde des flags qui l'exemptent
			} elseif { ($OMGYSU::shutup_table($shutup_table_id) eq "- - - $chan") && (($nick == $::botnick) || (![matchattr [nick2hand $nick] $OMGYSU::vg_exempted_flags $chan])) } {
				OMGYSU::putqueue "MODE $chan -o $arg"
			}
		}
		array donesearch OMGYSU::shutup_table $array_search_id
		return
	} elseif { $mode eq "-m" } {
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			if { $OMGYSU::shutup_table([array nextelement OMGYSU::shutup_table $array_search_id]) eq "- - - $chan" } {
				OMGYSU::putqueue "MODE $chan +m"
				array donesearch OMGYSU::shutup_table $array_search_id
				break
			}
		}
		return
	} elseif { $mode eq "-N" } {
		set array_search_id [array startsearch OMGYSU::shutup_table]
		while { [array anymore OMGYSU::shutup_table $array_search_id] } {
			if { $OMGYSU::shutup_table([array nextelement OMGYSU::shutup_table $array_search_id]) eq "- - - $chan" } {
				OMGYSU::putqueue "MODE $chan +N"
				array donesearch OMGYSU::shutup_table $array_search_id
				break
			}
		}
		return
	} else { return }
}

###
### Gnration de masques de type user!ident@host
###
proc OMGYSU::hostmask_process {nick host type} {
  set fullhost "$nick!$host"
  set nick "*" ; set ident "*" ; set host "*"
  scan $fullhost "%\[^!\]!%\[^@\]@%s" nick ident host
  set nick [join [string trimleft $nick "@+"]]
  set ident [join [string trimleft $ident "~"]]
  set hostmask $host
  if { [regexp {([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)} $host] } {
    set host [lreplace [split $host .] end end *]
  } else {
    set host [split $host .]
    if { [llength $host] == 3 } { set host [lreplace $host 0 0 *] }
    if { [llength $host] > 3 } { set host [lreplace $host 0 1 *] }
  }
  set domain [join $host .]
  switch "$type" {
    "0" { return "*!$ident@$hostmask" }
    "1" { return "*!*$ident@$hostmask" }
    "2" { return "*!*@$hostmask" }
    "3" { return "*!*$ident@$domain" }
    "4" { return "*!*@$domain" }
    "5" { return "$nick!$ident@$hostmask" }
    "6" { return "$nick!*$ident@$hostmask" }
    "7" { return "$nick!*@$hostmask" }
    "8" { return "$nick!*$ident@$domain" }
    "9" { return "$nick!*@$domain" }
		"10" { return "*!$ident@$domain" }
  }
  if {[set resultmask $nick!$ident@$fullhost] == "*!*@*"} { return "invalid!host@mask" }
  return $resultmask
} 

###
### file d'attente prioritaire
###
proc OMGYSU::putqueue {data} {
	if { $OMGYSU::fast_queue_compatibility } {
		putnow $data
	} else {
		append data "\n"
		putdccraw 0 [string length $data] $data
	}
	return
}

###
### Binds
###
bind pub $OMGYSU::chut_auth $OMGYSU::chut_cmd OMGYSU::you_shutup
bind pub $OMGYSU::vg_auth $OMGYSU::vg_cmd OMGYSU::everybody_shutup
bind mode -|- * OMGYSU::modes_management
bind evnt - prerehash OMGYSU::uninstall


putlog "\002$OMGYSU::scriptname v$OMGYSU::version\002 (2010 MenzAgitat) a t charg."
